; Beer Fight version 1.5 by Eikon
; **************************************

Graphics 200, 100, 16, 2
AppTitle "Beer Fight 1.5 Setup"
.BeerFight
Cls
Text 1, 1, "640, 480 16bpp"
Text 1, 15, "1)FullScreen"
Text 1, 30, "2)Window"
Locate 1, 45
choice=Input(">")
If choice=1 Then Graphics 640, 480, 16, 1: Goto begin
If choice=2 Then Graphics 640, 480, 16, 2: Goto begin Else Goto BeerFight
.Begin
AppTitle "Beer Fight version 1.5 by Eikon"
SetBuffer BackBuffer()

; Loading GFX/SFX
; **************************************
;GFX
Beer=LoadAnimImage("Beer.png", 43, 43, 0, 4): MaskImage Beer, 0, 0, 0
Mug=LoadAnimImage("Mug.png", 43, 43, 0, 4): MaskImage Mug, 0, 0, 0
Can=LoadAnimImage("Can.png", 43, 43, 0, 4): MaskImage Can, 0, 0, 0
Skull=LoadAnimImage("Skull.png", 50, 50, 0, 4): MaskImage Skull, 0, 0, 0

BeerFrame=0: BX = 0: BY = 0: State=0
BeerOfChoice=0:  BeerSound=0

Dude=LoadAnimImage("Pumpkin.png", 58, 60, 0, 9): MaskImage Dude, 0, 0, 0
DudeFrame=0: DX = 320: DY = 420

Fire=LoadAnimImage("Fire.png", 50, 40, 0, 10): MaskImage Fire, 0, 0, 0
FX = 0: FY = 0: FireFrame=0: FireState=0

Drop=LoadImage("Drop.png"): MaskImage Drop, 0, 0, 0

Type Water
	Field X
	Field Y
End Type

Title=LoadImage("TITLE.JPG")
Title2=LoadImage("Title2.JPG")
Title3=LoadImage("Title3.JPG")

L1Back=LoadImage("Level1Back.JPG")
L2Back=LoadImage("Level2Back.JPG")
L3Back=LoadImage("Level3Back.JPG")

Global Heart=LoadAnimImage("Heart.png", 35, 33, 0, 4): MaskImage Heart, 0, 0, 0
Global HeartFrame=0: Global Hearts=5

;SFX
Music=LoadSound("Music.wav")
Break1=LoadSound("Break1.wav")
Break2=LoadSound("Break2.wav")
Break3=LoadSound("Break3.wav")
Hit=LoadSound("Hit.wav")
Burn=LoadSound("Burn.wav")
Scream=LoadSound("Scream.wav")
Intro=LoadSound("Intro.wav")
Howl=LoadSound("Howl.wav")
SHit=LoadSound("Laugh.wav")
Splash=LoadSound("Drop.wav")

.Reset

;Timers
Timer=MilliSecs()
SeedRnd (MilliSecs())

; Score
Score = 0

; Current Level
Level=1

.Title
; Title Screen
; **************************************

If level=1 PlaySound Intro
If level=3 PlaySound Howl

While Not KeyDown(57)
Cls
If Level = 1 Then DrawImage Title, -13, 100
If Level = 2 Then DrawImage Title2, 0, 100
If Level = 3 Then DrawImage Title3, 0, 100
Flip
Wend

;Pick Our First Beer to Be Thrown
BeerOfChoice=Rand(1, 3)
If level=2 Then BeerOfChoice=1

; Main 
; **************************************
While Not KeyDown(1)
.Main
If MilliSecs()>Timer+100 Then Goto Render Else Goto Main

.Render
Timer=MilliSecs()
Cls

If Level=1 Then DrawImage L1Back, 0, 0
If Level=2 Then DrawImage L2Back, 0, 0
If Level=3 Then DrawImage L3Back, 0, 0

Text 1, 50, "Score:"
Text 50, 50, Score 

; Hearts
If Hearts=0 Then Goto Finish; Health Check
HeartFrame=HeartFrame+1: If HeartFrame=4 Then HeartFrame=0
HeartTotal(Hearts, HeartFrame)

; Beer
If State=0 Then BX=Rand(20, 620): State=1
If State=1 Then 
If DX > BX And level = 1 Then BX = BX + 10
If DX < BX And level = 1 Then BX = BX - 10
If DX > BX And level = 2 Then BX = BX + 10
If DX < BX And level = 2 Then BX = BX - 10
If DX > BX And level = 3 Then BX = BX + 8
If DX < BX And level = 3 Then BX = BX - 8
BY=BY+32
EndIf

; Gen Drops
TempX = Rnd(1, 2):  TempY = Rnd(1, 2)
If TempX = TempY And level =3 Then waterstate=1

; Water Drops
If waterstate= 1 Then
colec.Water = New Water
colec\X = Rnd(1,640)
colec\Y = 1
waterstate=2
EndIf

If waterstate=2 Then
For colec.Water = Each Water
colec\Y = colec\Y + 32
DrawImage Drop, colec\X, colec\Y
If colec\Y > 480 Then Delete colec: PlaySound Splash
Next
EndIf

; Fire
If firestate= 1 Then
DrawImage Fire, FX, FY, FireFrame
FireFrame=FireFrame + 1: If fireframe=10 Then fireframe =0
EndIf

; Collision
If ImagesCollide(Dude, DX, DY, 0, Beer, BX, BY, 0) And Level=2 Then 
Hearts = Hearts - 1: State=0: FireState=0: FX=-101: FY =-100: Score=Score-50
BS = 5
BeerFrame=0: BY = 0: BX = -50
Goto PlayerInput
EndIf

If ImagesCollide(Dude, DX, DY, 0, Fire, FX, FY, 0) And Level=2 Then 
Hearts = Hearts - 1: State=0: FireState=0: FX=-101: Fy=-100
Score=Score-50: BS=6
BeerFrame=0: BY = 0: BX = -50
Goto PlayerInput
EndIf

For colec.Water = Each Water
If ImagesCollide(Dude, DX, DY, 0, Drop, colec\X, colec\Y, 0) And Level=3 Then 
Hearts = Hearts - 1: State = 0: WaterState=0: Score=Score-50: BS = 6
Delete colec
EndIf
Next

If bY > 450 And Level = 2 Then FireState=1: FX = BX-10: FY = 450: FireFrame=0
If BY > 480 And Level = 2 Then State= 0: BeerFrame=0: Score = Score + 100: BY = 0: BX = -50: BS = 4

If ImagesCollide(Dude, DX, DY, 0, Beer, BX, BY, 0) And Level=1 Then Hearts = Hearts - 1: State = 0: BX=-45: BY=0: Score=Score-50: BeerOfChoice=Rand(1, 3): BS = 5
If BY > 480 And level=1 Then BY = 0: BX = -50: State= 0: BeerFrame=0: Score = Score + 100: BeerOfChoice=Rand(1, 3): BS = Rand(1, 3)

If ImagesCollide(Dude, DX, DY, 0, Beer, BX, BY, 0) And Level=3 Then Hearts = Hearts - 1: State = 0: BX=-45: BY=0: Score=Score-50: BS = 8
If BY > 480 And level=3 Then BY = 0: BX = -50: State= 0: BeerFrame=0: Score = Score + 100: BS = 7

; GFX / Input
.PlayerInput
DrawImage Dude, DX, DY, DudeFrame
If BeerOfChoice = 1 And level = 1 Then DrawImage Beer, BX, BY, BeerFrame
If BeerOfChoice = 2 And level = 1 Then DrawImage Mug, BX, BY, BeerFrame
If BeerOfChoice = 3 And level = 1 Then DrawImage Can, BX, BY, BeerFrame
If level = 2 Then DrawImage Beer, BX, BY, BeerFrame
If Level=3 Then DrawImage Skull, BX, BY, BeerFrame

DudeFrame=DudeFrame+1: If DudeFrame=9 Then DudeFrame=0
BeerFrame=BeerFrame+1: If BeerFrame=4 Then BeerFrame=0

If KeyDown(203) Then DX = DX - 12
If KeyDown(205) Then DX = DX + 12

; Bounderies
If DX < 0 Then DX = 0
If DX > 585 Then DX = 585

; SFX
If BS = 1 Then PlaySound Break1
If BS = 2 Then PlaySound Break2
If BS = 3 Then PlaySound Break3
If BS = 4 Then PlaySound Burn
If BS = 5 Then PlaySound Hit
If BS = 6 Then PlaySound Scream
If BS = 8 Then PlaySound SHit

BS = 0

.LeaveLoop
; Check Score for Next Level
If Score >= 999 And Level = 1 Then hearts=5: Level=2: Goto Title
If Score >= 1999 And Level = 2 Then hearts=5: firestate=0: Level=3: Goto Title

Flip
Wend
End

.Finish
Cls
Text 1, 1, "The Beer of your choice has ended your life tonight."
Text 1, 20, "Final Score:"
Text 100, 20, Score
If Score <= 0 Then Text 1, 40, "Bar Tender Jimmy Says: You Suck! Have a Milwaukee's Best."
If Score >= 0 And Score < 1000 Then Text 1, 40, "Bar Tender Jimmy Says: You're a disgrace to my bar. You deserve a Corona Extra."
If Score >= 1001 And Score < 2000 Then Text 1, 40, "Bar Tender Jimmy Says: You're Getting Better. Have a Miller High Life."
If Score >= 2001 And Score < 3000 Then Text 1, 40, "Bar Tender Jimmy Says: Looking good, Have a Foster's on the house!"
If Score >= 3001 And Score < 4000 Then Text 1, 40, "Bar Tender Jimmy Says: A new Bar record! Have a White Russian!"
If Score >= 4001 And Score < 5000 Then Text 1, 40, "Bar Tender Jimmy Says: You're a Jolly Good Fellow. Here's a round of Tequila shots."
If Score >= 5000 Then Text 1, 40, "Bar Tender Jimmy Says: Great Score! Lets celebrate with free drinks for all!"
FlushKeys
Flip
WaitKey
End

Function HeartTotal(Hearts, HeartFrame)
If Hearts=5 Then 
DrawImage Heart, 1, 1, HeartFrame
DrawImage Heart, 38, 1, HeartFrame
DrawImage Heart, 75, 1, HeartFrame
DrawImage Heart, 112, 1, HeartFrame
DrawImage Heart, 149, 1, HeartFrame
EndIf
If Hearts=4 Then 
DrawImage Heart, 1, 1, HeartFrame
DrawImage Heart, 38, 1, HeartFrame
DrawImage Heart, 75, 1, HeartFrame
DrawImage Heart, 112, 1, HeartFrame
EndIf
If Hearts=3 Then 
DrawImage Heart, 1, 1, HeartFrame
DrawImage Heart, 38, 1, HeartFrame
DrawImage Heart, 75, 1, HeartFrame
EndIf
If Hearts=2 Then 
DrawImage Heart, 1, 1, HeartFrame
DrawImage Heart, 38, 1, HeartFrame
EndIf
If Hearts=1 Then 
DrawImage Heart, 1, 1, HeartFrame
EndIf
End Function